//
//  mdlSpec.swift
//
//
//  Created by Michiel Carman on 1/24/24.
//

import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlSpec: Model, Content {
    static let schema = "spec"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Field(key: "name") var name: String?
    @Field(key: "numberOfTests") var numberoftests: Int?
    @Field(key: "isActive") var isactive: Bool?
    @Parent(key: "itemId") var item: mdlItem
    
    @Children(for: \.$spec) var specitems: [mdlSpecItem]
    @Children(for: \.$spec) var templatespecs: [mdlTemplateItemSpec]
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil, name: String? = nil, numberoftests: Int? = nil, isactive: Bool? = true, createuserid: Int? = nil, updateuserid: Int? = nil, itemid: Int) {
        self.id = id
        
        self.name = name
        self.numberoftests = numberoftests
        self.$item.$id.value = itemid
        self.isactive = isactive
        
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}

extension mdlSpec{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("spec")
                .field("id", .int, .identifier(auto: true))
                .field("name", .string)
                .field("numberOfTests", .int)
                .field("itemId", .int, .references("item", "id"))
                .field("isActive", .bool)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }

        func revert(on database: Database) async throws {
            try await database.schema("spec").delete()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlSpec>{
        
        let query = mdlSpec.query(on: req.db)
            .with(\.$item)
            .with(\.$specitems)
            .with(\.$templatespecs)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}



